thread.c File Reference
`#include "eval_intern.h"`
`#include "gc.h"`
`#include "internal.h"`
`#include "ruby/io.h"`

Go to the source code of this file.

## Data Structures

struct | rb_blocking_region_buffer
struct | rb_mutex_struct
struct | join_arg
struct | select_args
struct | thgroup
struct | thgroup_list_params
struct | exec_recursive_params
struct | event_call_args

## Macros

#define | USE_NATIVE_THREAD_PRIORITY 0
#define | RUBY_THREAD_PRIORITY_MAX 3
#define | RUBY_THREAD_PRIORITY_MIN -3
#define | THREAD_DEBUG 0
#define | eKillSignal INT2FIX(0)
#define | eTerminateSignal INT2FIX(1)
#define | closed_stream_error GET_VM()->special_exceptions[ruby_error_closed_stream]
#define | THREAD_SYSTEM_DEPENDENT_IMPLEMENTATION
#define | RB_GC_SAVE_MACHINE_CONTEXT(th)
#define | GVL_UNLOCK_BEGIN()
#define | GVL_UNLOCK_END()
#define | blocking_region_begin(th, region, func, arg)
#define | BLOCKING_REGION(exec, ubf, ubfarg)
#define | thread_debug if(0)printf
#define | thread_start_func_2(th, st, rst) thread_start_func_2(th, st)
#define | DELAY_INFTY 1E30
#define | THREAD_IO_WAITING_P(th)
#define | rb_fd_rcopy(d, s) (*(d) = *(s))
#define | GetMutexPtr(obj, tobj) TypedData_Get_Struct((obj), rb_mutex_t, &mutex_data_type, (tobj))
#define | mutex_mark NULL
#define | GetBarrierPtr(obj) ((VALUE)rb_check_typeddata((obj), &barrier_data_type))
#define | RUBY_EVENT_REMOVED 0x1000000
#define | rb_intern(str) rb_intern_const(str)

## Typedefs

typedef struct rb_mutex_struct | rb_mutex_t

## Enumerations

enum | { EVENT_RUNNING_NOTHING, EVENT_RUNNING_TRACE = 1, EVENT_RUNNING_THREAD = 2, EVENT_RUNNING_VM = 4, EVENT_RUNNING_EVENT_MASK = EVENT_RUNNING_VM|EVENT_RUNNING_THREAD }

## Functions

static void | sleep_timeval (rb_thread_t *th, struct timeval time)
static void | sleep_wait_for_interrupt (rb_thread_t *th, double sleepsec)
static void | sleep_forever (rb_thread_t *th, int nodeadlock)
static double | timeofday (void)
static int | rb_threadptr_dead (rb_thread_t *th)
static void | rb_check_deadlock (rb_vm_t *vm)
static void | st_delete_wrap (st_table *table, st_data_t key)
static void | set_unblock_function (rb_thread_t *th, rb_unblock_function_t *func, void *arg, struct rb_unblock_callback *old)
static void | reset_unblock_function (rb_thread_t *th, const struct rb_unblock_callback *old)
static void | blocking_region_end (rb_thread_t *th, struct rb_blocking_region_buffer *region)
| NOINLINE (static int thread_start_func_2(rb_thread_t *th, VALUE *stack_start, VALUE *register_stack_start))
static void | timer_thread_function (void *)
void | rb_vm_gvl_destroy (rb_vm_t *vm)
void | rb_thread_lock_unlock (rb_thread_lock_t *lock)
void | rb_thread_lock_destroy (rb_thread_lock_t *lock)
void | rb_threadptr_interrupt (rb_thread_t *th)
static int | terminate_i (st_data_t key, st_data_t val, rb_thread_t *main_thread)
static void | rb_mutex_abandon_all (rb_mutex_t *mutexes)
static const char * | rb_mutex_unlock_th (rb_mutex_t *mutex, rb_thread_t volatile *th)
void | rb_threadptr_unlock_all_locking_mutexes (rb_thread_t *th)
void | rb_thread_terminate_all (void)
static void | thread_cleanup_func_before_exec (void *th_ptr)
static void | thread_cleanup_func (void *th_ptr, int atfork)
static VALUE | rb_threadptr_raise (rb_thread_t *, int, VALUE *)
void | ruby_thread_init_stack (rb_thread_t *th)
static int | thread_start_func_2 (rb_thread_t *th, VALUE *stack_start, VALUE *register_stack_start)
static VALUE | thread_create_core (VALUE thval, VALUE args, VALUE(*fn)(ANYARGS))
static VALUE | thread_s_new (int argc, VALUE *argv, VALUE klass)
static VALUE | thread_start (VALUE klass, VALUE args)
static VALUE | thread_initialize (VALUE thread, VALUE args)
VALUE | rb_thread_create (VALUE(*fn)(ANYARGS), void *arg)
static VALUE | remove_from_join_list (VALUE arg)
static VALUE | thread_join_sleep (VALUE arg)
static VALUE | thread_join (rb_thread_t *target_th, double delay)
static VALUE | thread_join_m (int argc, VALUE *argv, VALUE self)
static VALUE | thread_value (VALUE self)
static struct timeval | double2timeval (double d)
static void | getclockofday (struct timeval *tp)
void | rb_thread_sleep_forever (void)
static void | rb_thread_sleep_deadly (void)
static void | sleep_for_polling (rb_thread_t *th)
void | rb_thread_wait_for (struct timeval time)
void | rb_thread_polling (void)
void | rb_thread_check_ints (void)
int | rb_thread_check_trap_pending (void)
int | rb_thread_interrupted (VALUE thval)
void | rb_thread_sleep (int sec)
static void | rb_threadptr_execute_interrupts_common (rb_thread_t *)
static void | rb_thread_schedule_limits (unsigned long limits_us)
void | rb_thread_schedule (void)
struct rb_blocking_region_buffer * | rb_thread_blocking_region_begin (void)
void | rb_thread_blocking_region_end (struct rb_blocking_region_buffer *region)
VALUE | rb_thread_blocking_region (rb_blocking_function_t *func, void *data1, rb_unblock_function_t *ubf, void *data2)
VALUE | rb_thread_io_blocking_region (rb_blocking_function_t *func, void *data1, int fd)
VALUE | rb_thread_call_without_gvl (rb_blocking_function_t *func, void *data1, rb_unblock_function_t *ubf, void *data2)
void * | rb_thread_call_with_gvl (void *(*func)(void *), void *data1)
int | ruby_thread_has_gvl_p (void)
static VALUE | thread_s_pass (VALUE klass)
void | rb_threadptr_execute_interrupts (rb_thread_t *th)
void | rb_thread_execute_interrupts (VALUE thval)
void | rb_gc_mark_threads (void)
static void | rb_threadptr_ready (rb_thread_t *th)
void | rb_threadptr_signal_raise (rb_thread_t *th, int sig)
void | rb_threadptr_signal_exit (rb_thread_t *th)
void | ruby_thread_stack_overflow (rb_thread_t *th)
int | rb_threadptr_set_raised (rb_thread_t *th)
int | rb_threadptr_reset_raised (rb_thread_t *th)
static int | thread_fd_close_i (st_data_t key, st_data_t val, st_data_t data)
void | rb_thread_fd_close (int fd)
static VALUE | thread_raise_m (int argc, VALUE *argv, VALUE self)
VALUE | rb_thread_kill (VALUE thread)
static VALUE | rb_thread_s_kill (VALUE obj, VALUE th)
static VALUE | rb_thread_exit (void)
VALUE | rb_thread_wakeup (VALUE thread)
VALUE | rb_thread_wakeup_alive (VALUE thread)
VALUE | rb_thread_run (VALUE thread)
VALUE | rb_thread_stop (void)
static int | thread_list_i (st_data_t key, st_data_t val, void *data)
VALUE | rb_thread_list (void)
VALUE | rb_thread_current (void)
static VALUE | thread_s_current (VALUE klass)
VALUE | rb_thread_main (void)
static VALUE | rb_thread_s_main (VALUE klass)
static VALUE | rb_thread_s_abort_exc (void)
static VALUE | rb_thread_s_abort_exc_set (VALUE self, VALUE val)
static VALUE | rb_thread_abort_exc (VALUE thread)
static VALUE | rb_thread_abort_exc_set (VALUE thread, VALUE val)
VALUE | rb_thread_group (VALUE thread)
static const char * | thread_status_name (enum rb_thread_status status)
static VALUE | rb_thread_status (VALUE thread)
static VALUE | rb_thread_alive_p (VALUE thread)
static VALUE | rb_thread_stop_p (VALUE thread)
static VALUE | rb_thread_safe_level (VALUE thread)
static VALUE | rb_thread_inspect (VALUE thread)
VALUE | rb_thread_local_aref (VALUE thread, ID id)
static VALUE | rb_thread_aref (VALUE thread, VALUE id)
VALUE | rb_thread_local_aset (VALUE thread, ID id, VALUE val)
static VALUE | rb_thread_aset (VALUE self, VALUE id, VALUE val)
static VALUE | rb_thread_key_p (VALUE self, VALUE key)
static int | thread_keys_i (ID key, VALUE value, VALUE ary)
static int | vm_living_thread_num (rb_vm_t *vm)
int | rb_thread_alone (void)
static VALUE | rb_thread_keys (VALUE self)
static VALUE | rb_thread_priority (VALUE thread)
static VALUE | rb_thread_priority_set (VALUE thread, VALUE prio)
static int | do_select (int n, rb_fdset_t *read, rb_fdset_t *write, rb_fdset_t *except, struct timeval *timeout)
static void | rb_thread_wait_fd_rw (int fd, int read)
void | rb_thread_wait_fd (int fd)
int | rb_thread_fd_writable (int fd)
int | rb_thread_select (int max, fd_set *read, fd_set *write, fd_set *except, struct timeval *timeout)
int | rb_thread_fd_select (int max, rb_fdset_t *read, rb_fdset_t *write, rb_fdset_t *except, struct timeval *timeout)
static rb_fdset_t * | init_set_fd (int fd, rb_fdset_t *fds)
static VALUE | select_single (VALUE ptr)
static VALUE | select_single_cleanup (VALUE ptr)
int | rb_wait_for_single_fd (int fd, int events, struct timeval *tv)
void | rb_gc_set_stack_end (VALUE **stack_end_p)
void | rb_gc_save_machine_context (rb_thread_t *th)
void | rb_threadptr_check_signal (rb_thread_t *mth)
void | rb_thread_stop_timer_thread (int close_anyway)
void | rb_thread_reset_timer_thread (void)
void | rb_thread_start_timer_thread (void)
static int | clear_coverage_i (st_data_t key, st_data_t val, st_data_t dummy)
static void | clear_coverage (void)
static void | rb_thread_atfork_internal (int(*atfork)(st_data_t, st_data_t, st_data_t))
static int | terminate_atfork_i (st_data_t key, st_data_t val, st_data_t current_th)
void | rb_thread_atfork (void)
static int | terminate_atfork_before_exec_i (st_data_t key, st_data_t val, st_data_t current_th)
void | rb_thread_atfork_before_exec (void)
static size_t | thgroup_memsize (const void *ptr)
static VALUE | thgroup_s_alloc (VALUE klass)
static int | thgroup_list_i (st_data_t key, st_data_t val, st_data_t data)
static VALUE | thgroup_list (VALUE group)
static VALUE | thgroup_enclose (VALUE group)
static VALUE | thgroup_enclosed_p (VALUE group)
static VALUE | thgroup_add (VALUE group, VALUE thread)
static void | mutex_free (void *ptr)
static size_t | mutex_memsize (const void *ptr)
VALUE | rb_obj_is_mutex (VALUE obj)
static VALUE | mutex_alloc (VALUE klass)
static VALUE | mutex_initialize (VALUE self)
VALUE | rb_mutex_new (void)
VALUE | rb_mutex_locked_p (VALUE self)
static void | mutex_locked (rb_thread_t *th, VALUE self)
VALUE | rb_mutex_trylock (VALUE self)
static int | lock_func (rb_thread_t *th, rb_mutex_t *mutex, int timeout_ms)
static void | lock_interrupt (void *ptr)
VALUE | rb_mutex_lock (VALUE self)
VALUE | rb_mutex_unlock (VALUE self)
static VALUE | rb_mutex_sleep_forever (VALUE time)
static VALUE | rb_mutex_wait_for (VALUE time)
VALUE | rb_mutex_sleep (VALUE self, VALUE timeout)
static VALUE | mutex_sleep (int argc, VALUE *argv, VALUE self)
VALUE | rb_mutex_synchronize (VALUE mutex, VALUE(*func)(VALUE arg), VALUE arg)
static void | barrier_mark (void *ptr)
static VALUE | barrier_alloc (VALUE klass)
VALUE | rb_barrier_new (void)
VALUE | rb_barrier_wait (VALUE self)
VALUE | rb_barrier_release (VALUE self)
VALUE | rb_barrier_destroy (VALUE self)
static VALUE | recursive_list_access (void)
static VALUE | recursive_check (VALUE list, VALUE obj_id, VALUE paired_obj_id)
static void | recursive_push (VALUE list, VALUE obj, VALUE paired_obj)
static void | recursive_pop (VALUE list, VALUE obj, VALUE paired_obj)
static VALUE | exec_recursive_i (VALUE tag, struct exec_recursive_params *p)
static VALUE | exec_recursive (VALUE(*func)(VALUE, VALUE, int), VALUE obj, VALUE pairid, VALUE arg, int outer)
VALUE | rb_exec_recursive (VALUE(*func)(VALUE, VALUE, int), VALUE obj, VALUE arg)
VALUE | rb_exec_recursive_paired (VALUE(*func)(VALUE, VALUE, int), VALUE obj, VALUE paired_obj, VALUE arg)
VALUE | rb_exec_recursive_outer (VALUE(*func)(VALUE, VALUE, int), VALUE obj, VALUE arg)
static VALUE | thread_suppress_tracing (rb_thread_t *th, int ev, VALUE(*func)(VALUE, int), VALUE arg, int always)
static rb_event_hook_t * | alloc_event_hook (rb_event_hook_func_t func, rb_event_flag_t events, VALUE data)
static void | thread_reset_event_flags (rb_thread_t *th)
static void | rb_threadptr_add_event_hook (rb_thread_t *th, rb_event_hook_func_t func, rb_event_flag_t events, VALUE data)
static rb_thread_t * | thval2thread_t (VALUE thval)
void | rb_thread_add_event_hook (VALUE thval, rb_event_hook_func_t func, rb_event_flag_t events, VALUE data)
static int | set_threads_event_flags_i (st_data_t key, st_data_t val, st_data_t flag)
static void | set_threads_event_flags (int flag)
static int | exec_event_hooks (const rb_event_hook_t *hook, rb_event_flag_t flag, VALUE self, ID id, VALUE klass)
static int | remove_defered_event_hook (rb_event_hook_t **root)
static VALUE | thread_exec_event_hooks (VALUE args, int running)
void | rb_threadptr_exec_event_hooks (rb_thread_t *th, rb_event_flag_t flag, VALUE self, ID id, VALUE klass)
void | rb_add_event_hook (rb_event_hook_func_t func, rb_event_flag_t events, VALUE data)
static int | defer_remove_event_hook (rb_event_hook_t *hook, rb_event_hook_func_t func)
static int | remove_event_hook (rb_event_hook_t **root, rb_event_hook_func_t func)
static int | rb_threadptr_remove_event_hook (rb_thread_t *th, rb_event_hook_func_t func)
int | rb_thread_remove_event_hook (VALUE thval, rb_event_hook_func_t func)
static rb_event_hook_t * | search_live_hook (rb_event_hook_t *hook)
static int | running_vm_event_hooks (st_data_t key, st_data_t val, st_data_t data)
static rb_thread_t * | vm_event_hooks_running_thread (rb_vm_t *vm)
int | rb_remove_event_hook (rb_event_hook_func_t func)
static int | clear_trace_func_i (st_data_t key, st_data_t val, st_data_t flag)
void | rb_clear_trace_func (void)
static void | call_trace_func (rb_event_flag_t, VALUE data, VALUE self, ID id, VALUE klass)
static VALUE | set_trace_func (VALUE obj, VALUE trace)
static void | thread_add_trace_func (rb_thread_t *th, VALUE trace)
static VALUE | thread_add_trace_func_m (VALUE obj, VALUE trace)
static VALUE | thread_set_trace_func_m (VALUE obj, VALUE trace)
static const char * | get_event_name (rb_event_flag_t event)
static VALUE | call_trace_proc (VALUE args, int tracing)
VALUE | ruby_suppress_tracing (VALUE(*func)(VALUE, int), VALUE arg, int always)
static VALUE | rb_thread_backtrace_m (VALUE thval)
void | Init_Thread (void)
int | ruby_native_thread_p (void)
static int | check_deadlock_i (st_data_t key, st_data_t val, int *found)
static void | update_coverage (rb_event_flag_t event, VALUE proc, VALUE self, ID id, VALUE klass)
VALUE | rb_get_coverages (void)
void | rb_set_coverages (VALUE coverages)
void | rb_reset_coverages (void)

## Variables

VALUE | rb_cMutex
VALUE | rb_cBarrier
static volatile int | system_working = 1
static const rb_data_type_t | thgroup_data_type
static const rb_data_type_t | mutex_data_type
static const rb_data_type_t | barrier_data_type
static ID | recursive_key

## Macro Definition Documentation

#define BLOCKING_REGION | ( |  | exec,
|  |  | ubf,
|  |  | ubfarg
| ) |  |

Value:
do { \
rb_thread_t *__th = GET_THREAD(); \
struct rb_blocking_region_buffer __region; \
blocking_region_begin(__th, &__region, (ubf), (ubfarg)); \
exec; \
blocking_region_end(__th, &__region); \
RUBY_VM_CHECK_INTS(); \
} while(0)

Definition at line 127 of file thread.c.

Referenced by do_select(), rb_thread_blocking_region(), and rb_thread_io_blocking_region().

#define blocking_region_begin | ( |  | th,
|  |  | region,
|  |  | func,
|  |  | arg
| ) |  |

Value:
do { \
(region)->prev_status = (th)->status; \
set_unblock_function((th), (func), (arg), &(region)->oldubf); \
(th)->blocking_region_buffer = (region); \
(th)->status = THREAD_STOPPED; \
thread_debug("enter blocking region (%p)\n", (void *)(th)); \
RB_GC_SAVE_MACHINE_CONTEXT(th); \
gvl_release((th)->vm); \
} while (0)

Definition at line 116 of file thread.c.

Referenced by rb_thread_blocking_region_begin(), and rb_thread_call_with_gvl().

#define closed_stream_error GET_VM()->special_exceptions[ruby_error_closed_stream]

Definition at line 77 of file thread.c.

Referenced by Init_Thread().

#define DELAY_INFTY 1E30

Definition at line 650 of file thread.c.

Referenced by thread_join(), thread_join_m(), and thread_value().

#define eKillSignal INT2FIX(0)

Definition at line 73 of file thread.c.

Referenced by rb_thread_kill(), and rb_threadptr_execute_interrupts_common().

#define eTerminateSignal INT2FIX(1)

Definition at line 74 of file thread.c.

Referenced by rb_threadptr_execute_interrupts_common(), and terminate_i().

#define GetBarrierPtr | ( |  | obj | ) | ((VALUE)rb_check_typeddata((obj), &barrier_data_type))

Definition at line 3765 of file thread.c.

Referenced by rb_barrier_destroy(), rb_barrier_release(), and rb_barrier_wait().

#define GetMutexPtr | ( |  | obj,
|  |  | tobj
| ) |  | TypedData_Get_Struct((obj), rb_mutex_t, &mutex_data_type, (tobj))

Definition at line 3357 of file thread.c.

Referenced by check_deadlock_i(), mutex_locked(), rb_barrier_wait(), rb_mutex_lock(), rb_mutex_locked_p(), rb_mutex_trylock(), and rb_mutex_unlock().

#define GVL_UNLOCK_BEGIN | ( |  | ) |

Value:
do { \
rb_thread_t *_th_stored = GET_THREAD(); \
RB_GC_SAVE_MACHINE_CONTEXT(_th_stored); \
gvl_release(_th_stored->vm);

Definition at line 106 of file thread.c.

Referenced by rb_mutex_lock().

#define GVL_UNLOCK_END | ( |  | ) |

Value:
gvl_acquire(_th_stored->vm, _th_stored); \
rb_thread_set_current(_th_stored); \
} while(0)

Definition at line 111 of file thread.c.

Referenced by rb_mutex_lock().

#define mutex_mark NULL

Definition at line 3362 of file thread.c.

#define rb_fd_rcopy | ( |  | d,
|  |  | s
| ) |  | (*(d) = *(s))

Definition at line 2515 of file thread.c.

Referenced by rb_thread_select().

#define RB_GC_SAVE_MACHINE_CONTEXT | ( |  | th | ) |

Value:
do { \
rb_gc_save_machine_context(th); \
SET_MACHINE_STACK_END(&(th)->machine_stack_end); \
} while (0)

Definition at line 100 of file thread.c.

Referenced by rb_thread_schedule_limits().

#define rb_intern | ( |  | str | ) | rb_intern_const(str)

#define RUBY_EVENT_REMOVED 0x1000000

Definition at line 4033 of file thread.c.

Referenced by defer_remove_event_hook(), exec_event_hooks(), remove_defered_event_hook(), remove_event_hook(), search_live_hook(), and thread_reset_event_flags().

#define RUBY_THREAD_PRIORITY_MAX 3

Definition at line 54 of file thread.c.

Referenced by rb_thread_priority_set().

#define RUBY_THREAD_PRIORITY_MIN -3

Definition at line 55 of file thread.c.

Referenced by rb_thread_priority_set().

#define THREAD_DEBUG 0

Definition at line 59 of file thread.c.

#define thread_debug if(0)printf

Definition at line 184 of file thread.c.

Referenced by blocking_region_end(), rb_thread_alone(), rb_thread_kill(), rb_thread_schedule_limits(), rb_thread_sleep_deadly(), rb_thread_sleep_forever(), rb_thread_terminate_all(), rb_thread_wait_fd_rw(), rb_threadptr_execute_interrupts_common(), sleep_timeval(), terminate_i(), thread_join(), thread_join_sleep(), and thread_start_func_2().

#define THREAD_IO_WAITING_P | ( |  | th | ) |

Value:
( \
((th)->status == THREAD_STOPPED || \
(th)->status == THREAD_STOPPED_FOREVER) && \
(th)->blocking_region_buffer && \
(th)->unblock.func == ubf_select && \
1)

Definition at line 1437 of file thread.c.

Referenced by thread_fd_close_i().

#define thread_start_func_2 | ( |  | th,
|  |  | st,
|  |  | rst
| ) |  | thread_start_func_2(th, st)

Definition at line 188 of file thread.c.

#define THREAD_SYSTEM_DEPENDENT_IMPLEMENTATION

Definition at line 87 of file thread.c.

#define USE_NATIVE_THREAD_PRIORITY 0

Definition at line 53 of file thread.c.

## Typedef Documentation

typedef struct rb_mutex_struct rb_mutex_t

## Enumeration Type Documentation

anonymous enum

Enumerator
EVENT_RUNNING_NOTHING |
EVENT_RUNNING_TRACE |
EVENT_RUNNING_THREAD |
EVENT_RUNNING_VM |
EVENT_RUNNING_EVENT_MASK |

Definition at line 4035 of file thread.c.

## Function Documentation

static rb_event_hook_t* alloc_event_hook | ( | rb_event_hook_func_t | func,
|  | rb_event_flag_t | events,
|  | VALUE | data
| ) |  |

static

Definition at line 4055 of file thread.c.

References ALLOC, rb_event_hook_struct::data, rb_event_hook_struct::flag, func, and rb_event_hook_struct::func.

Referenced by rb_add_event_hook(), and rb_threadptr_add_event_hook().

static VALUE barrier_alloc | ( | VALUE | klass | ) |

static

Definition at line 3760 of file thread.c.

References mutex_alloc(), and TypedData_Wrap_Struct.

Referenced by rb_barrier_new().

static void barrier_mark | ( | void * | ptr | ) |

static

Definition at line 3749 of file thread.c.

References rb_gc_mark().

static void blocking_region_end | ( | rb_thread_t * | th,
|  | struct rb_blocking_region_buffer * | region
| ) |  |

inline static

Definition at line 1045 of file thread.c.

References rb_thread_struct::blocking_region_buffer, rb_blocking_region_buffer::oldubf, rb_blocking_region_buffer::prev_status, rb_thread_set_current, reset_unblock_function(), rb_thread_struct::status, thread_debug, THREAD_STOPPED, and rb_thread_struct::vm.

Referenced by rb_thread_blocking_region_end(), and rb_thread_call_with_gvl().

static void call_trace_func | ( | rb_event_flag_t | event,
|  | VALUE | data,
|  | VALUE | self,
|  | ID | id,
|  | VALUE | klass
| ) |  |

static

Definition at line 4524 of file thread.c.

References call_trace_proc(), event_call_args::event, FALSE, GET_THREAD, id, event_call_args::id, event_call_args::klass, event_call_args::proc, ruby_suppress_tracing(), event_call_args::self, and event_call_args::th.

Referenced by set_trace_func(), thread_add_trace_func(), and thread_set_trace_func_m().

static VALUE call_trace_proc | ( | VALUE | args,
|  | int | tracing
| ) |  |

static

Definition at line 4484 of file thread.c.

References argv, event_call_args::event, FL_SINGLETON, FL_TEST, get_event_name(), event_call_args::id, ID2SYM, ID_ALLOCATOR, INT2FIX, event_call_args::klass, p, event_call_args::proc, Qnil, rb_binding_new(), rb_iv_get(), rb_proc_call_with_block(), rb_sourcefile, rb_sourceline(), rb_str_new2(), rb_thread_method_id_and_class(), RBASIC, event_call_args::self, T_ICLASS, event_call_args::th, and TYPE.

Referenced by call_trace_func().

static int check_deadlock_i | ( | st_data_t | key,
|  | st_data_t | val,
|  | int * | found
| ) |  |

static

Definition at line 4729 of file thread.c.

References rb_mutex_struct::cond_waiting, GetMutexPtr, GetThreadPtr, rb_mutex_struct::lock, rb_thread_struct::locking_mutex, RUBY_VM_INTERRUPTED, ST_CONTINUE, ST_STOP, rb_thread_struct::status, rb_mutex_struct::th, event_call_args::th, and THREAD_STOPPED_FOREVER.

Referenced by rb_check_deadlock().

static void clear_coverage | ( | void |  | ) |

static

Definition at line 3067 of file thread.c.

References clear_coverage_i(), rb_get_coverages(), RHASH_TBL, RTEST, and st_foreach.

Referenced by rb_thread_atfork_internal().

static int clear_coverage_i | ( | st_data_t | key,
|  | st_data_t | val,
|  | st_data_t | dummy
| ) |  |

static

Definition at line 3053 of file thread.c.

References i, INT2FIX, Qnil, RARRAY_LEN, RARRAY_PTR, and ST_CONTINUE.

Referenced by clear_coverage().

static int clear_trace_func_i | ( | st_data_t | key,
|  | st_data_t | val,
|  | st_data_t | flag
| ) |  |

static

Definition at line 4328 of file thread.c.

References GetThreadPtr, rb_threadptr_remove_event_hook(), ST_CONTINUE, and event_call_args::th.

Referenced by rb_clear_trace_func().

static int defer_remove_event_hook | ( | rb_event_hook_t * | hook,
|  | rb_event_hook_func_t | func
| ) |  |

static

Definition at line 4209 of file thread.c.

References rb_event_hook_struct::flag, rb_event_hook_struct::func, rb_event_hook_struct::next, and RUBY_EVENT_REMOVED.

Referenced by rb_remove_event_hook(), and rb_threadptr_remove_event_hook().

static int do_select | ( | int | n,
|  | rb_fdset_t * | read,
|  | rb_fdset_t * | write,
|  | rb_fdset_t * | except,
|  | struct timeval * | timeout
| ) |  |

static

Definition at line 2546 of file thread.c.

References BLOCKING_REGION, errno, GET_THREAD, gettimeofday(), NULL, rb_fd_dup, rb_fd_init_copy, rb_fd_select, rb_fd_term, result, timeofday(), timeval::tv_sec, timeval::tv_usec, UNINITIALIZED_VAR, and wait().

Referenced by rb_thread_fd_select().

static struct timeval double2timeval | ( | double | d | ) |

static read

Definition at line 830 of file thread.c.

References timeval::tv_sec, and timeval::tv_usec.

Referenced by sleep_wait_for_interrupt().

static int exec_event_hooks | ( | const rb_event_hook_t * | hook,
|  | rb_event_flag_t | flag,
|  | VALUE | self,
|  | ID | id,
|  | VALUE | klass
| ) |  |

inline static

Definition at line 4126 of file thread.c.

References rb_event_hook_struct::data, rb_event_hook_struct::flag, rb_event_hook_struct::func, rb_event_hook_struct::next, removed, and RUBY_EVENT_REMOVED.

Referenced by thread_exec_event_hooks().

static VALUE exec_recursive | ( | VALUE(*)(VALUE, VALUE, int) | func,
|  | VALUE | obj,
|  | VALUE | pairid,
|  | VALUE | arg,
|  | int | outer
| ) |  |

static

Definition at line 3961 of file thread.c.

References arg, exec_recursive_params::arg, exec_recursive_i(), func, exec_recursive_params::func, ID2SYM, exec_recursive_params::list, exec_recursive_params::obj, exec_recursive_params::objid, exec_recursive_params::pairid, Qundef, rb_catch_obj(), rb_obj_id(), rb_throw_obj(), recursive_check(), recursive_list_access(), recursive_pop(), recursive_push(), result, and TRUE.

Referenced by rb_exec_recursive(), rb_exec_recursive_outer(), and rb_exec_recursive_paired().

static VALUE exec_recursive_i | ( | VALUE | tag,
|  | struct exec_recursive_params * | p
| ) |  |

static

Definition at line 3932 of file thread.c.

References exec_recursive_params::arg, EXEC_TAG, FALSE, exec_recursive_params::func, JUMP_TAG, exec_recursive_params::list, exec_recursive_params::obj, exec_recursive_params::objid, exec_recursive_params::pairid, POP_TAG, PUSH_TAG, Qundef, recursive_pop(), recursive_push(), and result.

Referenced by exec_recursive().

static const char* get_event_name | ( | rb_event_flag_t | event | ) |

static

Definition at line 4459 of file thread.c.

References RUBY_EVENT_C_CALL, RUBY_EVENT_C_RETURN, RUBY_EVENT_CALL, RUBY_EVENT_CLASS, RUBY_EVENT_END, RUBY_EVENT_LINE, RUBY_EVENT_RAISE, and RUBY_EVENT_RETURN.

Referenced by call_trace_proc().

static void getclockofday | ( | struct timeval * | tp | ) |

static

Definition at line 865 of file thread.c.

References gettimeofday(), NULL, timespec::tv_nsec, timeval::tv_sec, timespec::tv_sec, and timeval::tv_usec.

Referenced by sleep_timeval().

static rb_fdset_t* init_set_fd | ( | int | fd,
|  | rb_fdset_t * | fds
| ) |  |

static

Definition at line 2896 of file thread.c.

References rb_fd_init, and rb_fd_set.

Referenced by rb_wait_for_single_fd().

void Init_Thread | ( | void |  | ) |

Definition at line 4619 of file thread.c.

References closed_stream_error, GET_THREAD, rb_thread_struct::interrupt_lock, mutex_alloc(), mutex_initialize(), mutex_sleep(), OBJ_FREEZE, OBJ_TAINT, rb_cMutex, rb_cObject, rb_cThread, rb_define_alloc_func(), rb_define_class(), rb_define_const(), rb_define_global_function(), rb_define_method(), rb_define_singleton_method(), rb_eIOError, rb_eStandardError, rb_eThreadError, rb_exc_new2(), rb_intern, rb_mutex_lock(), rb_mutex_locked_p(), rb_mutex_trylock(), rb_mutex_unlock(), rb_obj_alloc(), rb_thread_abort_exc(), rb_thread_abort_exc_set(), rb_thread_alive_p(), rb_thread_aref(), rb_thread_aset(), rb_thread_backtrace_m(), rb_thread_exit(), rb_thread_group(), rb_thread_inspect(), rb_thread_key_p(), rb_thread_keys(), rb_thread_kill(), rb_thread_list(), rb_thread_priority(), rb_thread_priority_set(), rb_thread_run(), rb_thread_s_abort_exc(), rb_thread_s_abort_exc_set(), rb_thread_s_kill(), rb_thread_s_main(), rb_thread_safe_level(), rb_thread_stop(), rb_thread_stop_p(), rb_thread_wakeup(), set_trace_func(), rb_thread_struct::thgroup, thgroup_add(), rb_vm_struct::thgroup_default, thgroup_enclose(), thgroup_enclosed_p(), thgroup_list(), thgroup_s_alloc(), thread_add_trace_func_m(), thread_initialize(), thread_join_m(), thread_raise_m(), thread_s_current(), thread_s_new(), thread_s_pass(), thread_set_trace_func_m(), thread_start(), thread_value(), and rb_thread_struct::vm.

static int lock_func | ( | rb_thread_t * | th,
|  | rb_mutex_t * | mutex,
|  | int | timeout_ms
| ) |  |

static

Definition at line 3485 of file thread.c.

References rb_mutex_struct::cond, rb_mutex_struct::cond_waiting, err, ETIMEDOUT, rb_mutex_struct::lock, RUBY_VM_INTERRUPTED, rb_mutex_struct::th, timespec::tv_nsec, and timespec::tv_sec.

Referenced by rb_mutex_lock().

static void lock_interrupt | ( | void * | ptr | ) |

static

Definition at line 3525 of file thread.c.

References rb_mutex_struct::cond, rb_mutex_struct::cond_waiting, and rb_mutex_struct::lock.

Referenced by rb_mutex_lock().

static VALUE mutex_alloc | ( | VALUE | klass | ) |

static

Definition at line 3403 of file thread.c.

References rb_mutex_struct::cond, rb_mutex_struct::lock, and TypedData_Make_Struct.

Referenced by barrier_alloc(), Init_Thread(), and rb_mutex_new().

static void mutex_free | ( | void * | ptr | ) |

static

Definition at line 3365 of file thread.c.

References rb_mutex_struct::cond, err, rb_mutex_struct::lock, rb_bug(), rb_mutex_unlock_th(), ruby_xfree(), and rb_mutex_struct::th.

static VALUE mutex_initialize | ( | VALUE | self | ) |

static

Definition at line 3421 of file thread.c.

Referenced by Init_Thread().

static void mutex_locked | ( | rb_thread_t * | th,
|  | VALUE | self
| ) |  |

static

Definition at line 3447 of file thread.c.

References GetMutexPtr, rb_thread_struct::keeping_mutexes, and rb_mutex_struct::next_mutex.

Referenced by rb_mutex_lock(), and rb_mutex_trylock().

static size_t mutex_memsize | ( | const void * | ptr | ) |

static

Definition at line 3381 of file thread.c.

static VALUE mutex_sleep | ( | int | argc,
|  | VALUE * | argv,
|  | VALUE | self
| ) |  |

static

Definition at line 3722 of file thread.c.

References rb_mutex_sleep(), and rb_scan_args().

Referenced by Init_Thread().

NOINLINE | ( | static int | thread_start_func_2rb_thread_t *th, VALUE *stack_start, VALUE *register_stack_start | ) |

void rb_add_event_hook | ( | rb_event_hook_func_t | func,
|  | rb_event_flag_t | events,
|  | VALUE | data
| ) |  |

Definition at line 4197 of file thread.c.

References alloc_event_hook(), rb_vm_struct::event_hooks, GET_VM, rb_event_hook_struct::next, and set_threads_event_flags().

Referenced by rb_set_coverages(), and set_trace_func().

VALUE rb_barrier_destroy | ( | VALUE | self | ) |

Definition at line 3797 of file thread.c.

References DATA_PTR, GetBarrierPtr, and rb_mutex_unlock().

Referenced by load_unlock().

VALUE rb_barrier_new | ( | void |  | ) |

Definition at line 3768 of file thread.c.

References barrier_alloc(), DATA_PTR, rb_cBarrier, and rb_mutex_lock().

Referenced by load_lock().

VALUE rb_barrier_release | ( | VALUE | self | ) |

Definition at line 3791 of file thread.c.

References GetBarrierPtr, and rb_mutex_unlock().

Referenced by load_unlock().

VALUE rb_barrier_wait | ( | VALUE | self | ) |

Definition at line 3776 of file thread.c.

References DATA_PTR, GET_THREAD, GetBarrierPtr, GetMutexPtr, Qfalse, Qtrue, rb_mutex_lock(), rb_mutex_unlock(), and rb_mutex_struct::th.

Referenced by load_lock().

static void rb_check_deadlock | ( | rb_vm_t * | vm | ) |

static

Definition at line 4777 of file thread.c.

References argv, check_deadlock_i(), GET_THREAD, rb_vm_struct::living_threads, rb_vm_struct::main_thread, st_table::num_entries, rb_bug(), rb_eFatal, rb_str_new2(), rb_threadptr_raise(), rb_vm_struct::sleeper, st_foreach, and vm_living_thread_num().

Referenced by rb_mutex_lock(), sleep_forever(), and thread_start_func_2().

void rb_clear_trace_func | ( | void |  | ) |

Definition at line 4337 of file thread.c.

References clear_trace_func_i(), GET_VM, rb_remove_event_hook(), and st_foreach.

Referenced by ruby_finalize_0(), and ruby_options().

VALUE rb_exec_recursive | ( | VALUE(*)(VALUE, VALUE, int) | func,
|  | VALUE | obj,
|  | VALUE | arg
| ) |  |

Definition at line 4004 of file thread.c.

References exec_recursive(), and func.

Referenced by ary_join_1(), enumerator_inspect(), range_inspect(), rb_ary_inspect(), rb_file_join(), rb_hash_inspect(), rb_io_puts(), rb_obj_inspect(), and rb_struct_inspect().

VALUE rb_exec_recursive_outer | ( | VALUE(*)(VALUE, VALUE, int) | func,
|  | VALUE | obj,
|  | VALUE | arg
| ) |  |

Definition at line 4027 of file thread.c.

References exec_recursive(), and func.

Referenced by range_hash(), rb_ary_hash(), rb_hash_hash(), and rb_struct_hash().

VALUE rb_exec_recursive_paired | ( | VALUE(*)(VALUE, VALUE, int) | func,
|  | VALUE | obj,
|  | VALUE | paired_obj,
|  | VALUE | arg
| ) |  |

Definition at line 4015 of file thread.c.

References exec_recursive(), func, and rb_obj_id().

Referenced by hash_equal(), range_eq(), range_eql(), rb_ary_cmp(), rb_ary_eql(), rb_ary_equal(), rb_struct_eql(), and rb_struct_equal().

void rb_gc_mark_threads | ( | void |  | ) |

Definition at line 1347 of file thread.c.

References rb_bug().

void rb_gc_save_machine_context | ( | rb_thread_t * | th | ) |

Definition at line 2985 of file thread.c.

References FLUSH_REGISTER_WINDOWS, and rb_thread_struct::machine_regs.

void rb_gc_set_stack_end | ( | VALUE ** | stack_end_p | ) |

Definition at line 2977 of file thread.c.

VALUE rb_get_coverages | ( | void |  | ) |

Definition at line 4817 of file thread.c.

References GET_VM.

Referenced by clear_coverage(), coverage(), prepare_iseq_build(), rb_coverage_result(), and rb_coverage_start().

static void rb_mutex_abandon_all | ( | rb_mutex_t * | mutexes | ) |

static

Definition at line 3665 of file thread.c.

References rb_mutex_struct::next_mutex, and rb_mutex_struct::th.

Referenced by terminate_atfork_i().

VALUE rb_mutex_lock | ( | VALUE | self | ) |

Definition at line 3542 of file thread.c.

References GET_THREAD, GetMutexPtr, GVL_UNLOCK_BEGIN, GVL_UNLOCK_END, rb_mutex_struct::lock, lock_func(), lock_interrupt(), rb_thread_struct::locking_mutex, mutex_locked(), Qfalse, rb_check_deadlock(), rb_eThreadError, rb_mutex_trylock(), rb_raise(), reset_unblock_function(), RUBY_VM_CHECK_INTS, set_unblock_function(), rb_vm_struct::sleeper, rb_thread_struct::status, rb_mutex_struct::th, THREAD_STOPPED_FOREVER, rb_thread_struct::vm, and vm_living_thread_num().

Referenced by Init_Thread(), rb_barrier_new(), rb_barrier_wait(), rb_mutex_sleep(), and rb_mutex_synchronize().

VALUE rb_mutex_locked_p | ( | VALUE | self | ) |

Definition at line 3439 of file thread.c.

References GetMutexPtr, Qfalse, Qtrue, and rb_mutex_struct::th.

Referenced by Init_Thread().

VALUE rb_mutex_new | ( | void |  | ) |

Definition at line 3427 of file thread.c.

References mutex_alloc(), and rb_cMutex.

Referenced by io_binwrite().

VALUE rb_mutex_sleep | ( | VALUE | self,
|  | VALUE | timeout
| ) |  |

Definition at line 3693 of file thread.c.

References INT2FIX, NIL_P, Qnil, rb_ensure(), rb_mutex_lock(), rb_mutex_sleep_forever(), rb_mutex_unlock(), rb_mutex_wait_for(), rb_time_interval(), and time_t.

Referenced by mutex_sleep().

static VALUE rb_mutex_sleep_forever | ( | VALUE | time | ) |

static

Definition at line 3678 of file thread.c.

References Qnil, and rb_thread_sleep_deadly().

Referenced by rb_mutex_sleep().

VALUE rb_mutex_synchronize | ( | VALUE | mutex,
|  | VALUE(*)(VALUE arg) | func,
|  | VALUE | arg
| ) |  |

Definition at line 3739 of file thread.c.

References func, rb_ensure(), rb_mutex_lock(), and rb_mutex_unlock().

Referenced by fptr_finalize(), io_binwrite(), and io_flush_buffer().

VALUE rb_mutex_trylock | ( | VALUE | self | ) |

Definition at line 3466 of file thread.c.

References GET_THREAD, GetMutexPtr, rb_mutex_struct::lock, mutex_locked(), Qfalse, Qtrue, and rb_mutex_struct::th.

Referenced by Init_Thread(), and rb_mutex_lock().

VALUE rb_mutex_unlock | ( | VALUE | self | ) |

Definition at line 3652 of file thread.c.

References err, GET_THREAD, GetMutexPtr, rb_eThreadError, rb_mutex_unlock_th(), and rb_raise().

Referenced by Init_Thread(), rb_barrier_destroy(), rb_barrier_release(), rb_barrier_wait(), rb_mutex_sleep(), and rb_mutex_synchronize().

static const char * rb_mutex_unlock_th | ( | rb_mutex_t * | mutex,
|  | rb_thread_t volatile * | th
| ) |  |

static

Definition at line 3601 of file thread.c.

References rb_mutex_struct::cond, rb_mutex_struct::cond_waiting, err, rb_thread_struct::keeping_mutexes, rb_mutex_struct::lock, rb_mutex_struct::next_mutex, NULL, and rb_mutex_struct::th.

Referenced by mutex_free(), rb_mutex_unlock(), and rb_threadptr_unlock_all_locking_mutexes().

static VALUE rb_mutex_wait_for | ( | VALUE | time | ) |

static

Definition at line 3685 of file thread.c.

References Qnil, and rb_thread_wait_for().

Referenced by rb_mutex_sleep().

VALUE rb_obj_is_mutex | ( | VALUE | obj | ) |

Definition at line 3392 of file thread.c.

References Qfalse, Qtrue, and rb_typeddata_is_kind_of().

Referenced by rb_objspace_call_finalizer().

int rb_remove_event_hook | ( | rb_event_hook_func_t | func | ) |

Definition at line 4307 of file thread.c.

References defer_remove_event_hook(), rb_vm_struct::event_hooks, GET_VM, remove_event_hook(), search_live_hook(), set_threads_event_flags(), and vm_event_hooks_running_thread().

Referenced by rb_clear_trace_func(), rb_reset_coverages(), and set_trace_func().

void rb_reset_coverages | ( | void |  | ) |

Definition at line 4830 of file thread.c.

References GET_VM, Qfalse, rb_remove_event_hook(), and update_coverage().

Referenced by rb_coverage_result().

void rb_set_coverages | ( | VALUE | coverages | ) |

Definition at line 4823 of file thread.c.

References GET_VM, Qnil, rb_add_event_hook(), RUBY_EVENT_COVERAGE, and update_coverage().

Referenced by rb_coverage_start().

static VALUE rb_thread_abort_exc | ( | VALUE | thread | ) |

static

Definition at line 1829 of file thread.c.

References rb_thread_struct::abort_on_exception, GetThreadPtr, Qfalse, and Qtrue.

Referenced by Init_Thread().

static VALUE rb_thread_abort_exc_set | ( | VALUE | thread,
|  | VALUE | val
| ) |  |

static

Definition at line 1847 of file thread.c.

References rb_thread_struct::abort_on_exception, GetThreadPtr, rb_secure(), and RTEST.

Referenced by Init_Thread().

void rb_thread_add_event_hook | ( | VALUE | thval,
|  | rb_event_hook_func_t | func,
|  | rb_event_flag_t | events,
|  | VALUE | data
| ) |  |

Definition at line 4097 of file thread.c.

References rb_threadptr_add_event_hook(), and thval2thread_t().

static VALUE rb_thread_alive_p | ( | VALUE | thread | ) |

static

Definition at line 1959 of file thread.c.

References GetThreadPtr, Qfalse, Qtrue, and rb_threadptr_dead().

Referenced by call_queue_handler(), eval_queue_handler(), Init_Thread(), invoke_queue_handler(), lib_eventloop_ensure(), and lib_thread_callback().

int rb_thread_alone | ( | void |  | ) |

Definition at line 2168 of file thread.c.

References GET_THREAD, thread_debug, and vm_living_thread_num().

Referenced by io_writable_length(), ip_rb_threadTkWaitCommand(), ip_rb_threadUpdateCommand(), ip_rb_threadVwaitCommand(), ip_rbTkWaitCommand(), ip_rbVwaitCommand(), lib_eventloop_core(), rb_thread_polling(), rb_thread_schedule_limits(), rb_thread_stop(), rb_thread_terminate_all(), rb_thread_wait_fd_rw(), and rb_waitpid().

static VALUE rb_thread_aref | ( | VALUE | thread,
|  | VALUE | id
| ) |  |

static

Definition at line 2082 of file thread.c.

References rb_thread_local_aref(), and rb_to_id().

Referenced by Init_Thread().

static VALUE rb_thread_aset | ( | VALUE | self,
|  | VALUE | id,
|  | VALUE | val
| ) |  |

static

Definition at line 2119 of file thread.c.

References rb_thread_local_aset(), and rb_to_id().

Referenced by Init_Thread().

void rb_thread_atfork | ( | void |  | ) |

Definition at line 3109 of file thread.c.

References GET_THREAD, rb_reset_random_seed(), rb_thread_atfork_internal(), and terminate_atfork_i().

Referenced by pipe_open().

void rb_thread_atfork_before_exec | ( | void |  | ) |

Definition at line 3132 of file thread.c.

References rb_thread_atfork_internal(), and terminate_atfork_before_exec_i().

Referenced by chfunc().

static void rb_thread_atfork_internal | ( | int(*)(st_data_t, st_data_t, st_data_t) | atfork | ) |

static

Definition at line 3076 of file thread.c.

References clear_coverage(), GET_THREAD, rb_vm_struct::living_threads, rb_vm_struct::main_thread, rb_thread_struct::self, rb_vm_struct::sleeper, st_clear(), st_foreach, st_insert, and rb_thread_struct::vm.

Referenced by rb_thread_atfork(), and rb_thread_atfork_before_exec().

static VALUE rb_thread_backtrace_m | ( | VALUE | thval | ) |

static

Definition at line 4590 of file thread.c.

References rb_thread_backtrace().

Referenced by Init_Thread().

VALUE rb_thread_blocking_region | ( | rb_blocking_function_t * | func,
|  | void * | data1,
|  | rb_unblock_function_t * | ubf,
|  | void * | data2
| ) |  |

Definition at line 1115 of file thread.c.

References BLOCKING_REGION, errno, func, GET_THREAD, RUBY_UBF_IO, RUBY_UBF_PROCESS, and rb_thread_struct::waiting_fd.

Referenced by bigdivrem(), copy_stream_body(), curses_getch(), curses_getstr(), rb_sysopen_internal(), rb_thread_call_without_gvl(), rb_waitpid(), window_getch(), and window_getstr().

struct rb_blocking_region_buffer* rb_thread_blocking_region_begin | ( | void |  | ) |

read

Definition at line 1059 of file thread.c.

References ALLOC, blocking_region_begin, and GET_THREAD.

void rb_thread_blocking_region_end | ( | struct rb_blocking_region_buffer * | region | ) |

Definition at line 1068 of file thread.c.

References blocking_region_end(), errno, GET_THREAD, RUBY_VM_CHECK_INTS, and xfree().

void* rb_thread_call_with_gvl | ( | void *(*)(void *) | func,
|  | void * | data1
| ) |  |

Definition at line 1199 of file thread.c.

References rb_unblock_callback::arg, blocking_region_begin, rb_thread_struct::blocking_region_buffer, blocking_region_end(), EXIT_FAILURE, rb_unblock_callback::func, if(), rb_bug(), and rb_thread_struct::unblock.

Referenced by garbage_collect_with_gvl(), maygvl_copy_stream_continue_p(), negative_size_allocation_error(), and ruby_memerror().

VALUE rb_thread_call_without_gvl | ( | rb_blocking_function_t * | func,
|  | void * | data1,
|  | rb_unblock_function_t * | ubf,
|  | void * | data2
| ) |  |

Definition at line 1159 of file thread.c.

References rb_thread_blocking_region().

void rb_thread_check_ints | ( | void |  | ) |

Definition at line 983 of file thread.c.

References RUBY_VM_CHECK_INTS.

Referenced by bigmul1_normal(), collect_all(), lib_eventloop_core(), and trap_check().

int rb_thread_check_trap_pending | ( | void |  | ) |

Definition at line 993 of file thread.c.

References rb_signal_buff_size().

Referenced by ip_rbTkWaitCommand(), ip_rbUpdateCommand(), ip_rbVwaitCommand(), and trap_check().

VALUE rb_thread_create | ( | VALUE(*)(ANYARGS) | fn,
|  | void * | arg
| ) |  |

Definition at line 643 of file thread.c.

References rb_cThread, rb_thread_alloc(), and thread_create_core().

Referenced by lib_thread_callback(), lib_watchdog_core(), and rb_detach_process().

VALUE rb_thread_current | ( | void |  | ) |

Definition at line 1727 of file thread.c.

References GET_THREAD.

Referenced by call_queue_handler(), chdir_yield(), copy_stream_body(), dir_s_chdir(), eval_queue_handler(), eventloop_sleep(), invoke_queue_handler(), ip_eval(), ip_invoke_real(), ip_invoke_with_position(), ip_rb_threadTkWaitCommand(), ip_rb_threadUpdateCommand(), ip_rb_threadVwaitCommand(), ip_rbTkWaitCommand(), ip_rbVwaitCommand(), lib_eventloop_ensure(), lib_eventloop_launcher(), lib_evloop_thread_p(), lib_watchdog_core(), rb_dl_get_last_error(), rb_dl_set_last_error(), recursive_list_access(), recursive_pop(), thread_s_current(), tk_funcall(), VpGetException(), VpGetPrecLimit(), and VpGetRoundMode().

void rb_thread_execute_interrupts | ( | VALUE | thval | ) |

Definition at line 1339 of file thread.c.

References GetThreadPtr, and rb_threadptr_execute_interrupts_common().

Referenced by exec_interrupts(), and maygvl_copy_stream_continue_p().

static VALUE rb_thread_exit | ( | void |  | ) |

static

Definition at line 1571 of file thread.c.

References GET_THREAD, and rb_thread_kill().

Referenced by Init_Thread().

void rb_thread_fd_close | ( | int | fd | ) |

Definition at line 1464 of file thread.c.

References GET_THREAD, st_foreach, and thread_fd_close_i().

Referenced by io_reopen(), and rb_io_close().

int rb_thread_fd_select | ( | int | max,
|  | rb_fdset_t * | read,
|  | rb_fdset_t * | write,
|  | rb_fdset_t * | except,
|  | struct timeval * | timeout
| ) |  |

Definition at line 2754 of file thread.c.

References do_select(), rb_fd_resize, rb_thread_sleep_forever(), and rb_thread_wait_for().

Referenced by maygvl_select(), rb_thread_select(), select_internal(), and select_single().

int rb_thread_fd_writable | ( | int | fd | ) |

Definition at line 2703 of file thread.c.

References rb_thread_wait_fd_rw(), and TRUE.

Referenced by io_binwrite(), io_fflush(), rb_io_syswrite(), rb_io_wait_writable(), rsock_bsock_send(), and udp_send().

VALUE rb_thread_group | ( | VALUE | thread | ) |

Definition at line 1869 of file thread.c.

References GetThreadPtr, Qnil, and rb_thread_struct::thgroup.

Referenced by Init_Thread().

static VALUE rb_thread_inspect | ( | VALUE | thread | ) |

static

Definition at line 2023 of file thread.c.

References GetThreadPtr, OBJ_INFECT, rb_obj_classname(), rb_sprintf(), rb_thread_struct::status, and thread_status_name().

Referenced by Init_Thread().

int rb_thread_interrupted | ( | VALUE | thval | ) |

Definition at line 1000 of file thread.c.

References GetThreadPtr, and RUBY_VM_INTERRUPTED.

Referenced by maygvl_copy_stream_continue_p().

VALUE rb_thread_io_blocking_region | ( | rb_blocking_function_t * | func,
|  | void * | data1,
|  | int | fd
| ) |  |

Definition at line 1139 of file thread.c.

References BLOCKING_REGION, errno, func, GET_THREAD, and rb_thread_struct::waiting_fd.

Referenced by io_cntl(), io_flush_buffer_async(), rb_file_flock(), rb_read_internal(), and rb_write_internal().

static VALUE rb_thread_key_p | ( | VALUE | self,
|  | VALUE | key
| ) |  |

static

Definition at line 2138 of file thread.c.

References GetThreadPtr, rb_thread_struct::local_storage, Qfalse, Qtrue, rb_to_id(), and st_lookup.

Referenced by Init_Thread().

static VALUE rb_thread_keys | ( | VALUE | self | ) |

static

Definition at line 2193 of file thread.c.

References GetThreadPtr, rb_thread_struct::local_storage, rb_ary_new(), st_foreach, and thread_keys_i().

Referenced by Init_Thread().

VALUE rb_thread_kill | ( | VALUE | thread | ) |

Definition at line 1513 of file thread.c.

References eKillSignal, EXIT_SUCCESS, GET_THREAD, GetThreadPtr, rb_vm_struct::main_thread, rb_exit(), rb_secure(), rb_threadptr_interrupt(), rb_thread_struct::safe_level, rb_thread_struct::status, thread_debug, rb_thread_struct::thread_id, THREAD_KILLED, THREAD_TO_KILL, rb_thread_struct::thrown_errinfo, and rb_thread_struct::vm.

Referenced by Init_Thread(), rb_thread_exit(), and rb_thread_s_kill().

VALUE rb_thread_list | ( | void |  | ) |

Definition at line 1719 of file thread.c.

References GET_THREAD, rb_ary_new(), st_foreach, and thread_list_i().

Referenced by Init_Thread().

VALUE rb_thread_local_aref | ( | VALUE | thread,
|  | ID | id
| ) |  |

Definition at line 2039 of file thread.c.

References GET_THREAD, GetThreadPtr, rb_thread_struct::local_storage, Qnil, rb_eSecurityError, rb_raise(), rb_safe_level, and st_lookup.

Referenced by detach_process_pid(), rb_dl_get_last_error(), rb_thread_aref(), recursive_list_access(), VpGetException(), VpGetPrecLimit(), and VpGetRoundMode().

VALUE rb_thread_local_aset | ( | VALUE | thread,
|  | ID | id,
|  | VALUE | val
| ) |  |

Definition at line 2088 of file thread.c.

References GET_THREAD, GetThreadPtr, rb_thread_struct::local_storage, NIL_P, OBJ_FROZEN, Qnil, rb_error_frozen(), rb_eSecurityError, rb_raise(), rb_safe_level, st_delete_wrap(), st_init_numtable, and st_insert.

Referenced by rb_detach_process(), rb_dl_set_last_error(), rb_thread_aset(), and recursive_list_access().

void rb_thread_lock_destroy | ( | rb_thread_lock_t * | lock | ) |

Definition at line 259 of file thread.c.

void rb_thread_lock_unlock | ( | rb_thread_lock_t * | lock | ) |

Definition at line 253 of file thread.c.

VALUE rb_thread_main | ( | void |  | ) |

Definition at line 1748 of file thread.c.

References GET_THREAD.

Referenced by rb_thread_s_main().

void rb_thread_polling | ( | void |  | ) |

Definition at line 966 of file thread.c.

References GET_THREAD, rb_thread_alone(), RUBY_VM_CHECK_INTS, and sleep_for_polling().

Referenced by rb_f_kill(), and rb_file_flock().

static VALUE rb_thread_priority | ( | VALUE | thread | ) |

static

Definition at line 2221 of file thread.c.

References GetThreadPtr, INT2NUM(), and rb_thread_struct::priority.

Referenced by Init_Thread().

static VALUE rb_thread_priority_set | ( | VALUE | thread,
|  | VALUE | prio
| ) |  |

static

Definition at line 2256 of file thread.c.

References GetThreadPtr, INT2NUM(), NUM2INT, rb_thread_struct::priority, rb_secure(), RUBY_THREAD_PRIORITY_MAX, and RUBY_THREAD_PRIORITY_MIN.

Referenced by Init_Thread().

int rb_thread_remove_event_hook | ( | VALUE | thval,
|  | rb_event_hook_func_t | func
| ) |  |

Definition at line 4273 of file thread.c.

References rb_threadptr_remove_event_hook(), and thval2thread_t().

void rb_thread_reset_timer_thread | ( | void |  | ) |

Definition at line 3040 of file thread.c.

Referenced by after_exec().

VALUE rb_thread_run | ( | VALUE | thread | ) |

Definition at line 1640 of file thread.c.

References rb_thread_schedule(), and rb_thread_wakeup().

Referenced by call_queue_handler(), eval_queue_handler(), Init_Thread(), invoke_queue_handler(), lib_eventloop_launcher(), and lib_watchdog_core().

static VALUE rb_thread_s_abort_exc | ( | void |  | ) |

static

Definition at line 1780 of file thread.c.

References GET_THREAD, Qfalse, and Qtrue.

Referenced by Init_Thread().

static VALUE rb_thread_s_abort_exc_set | ( | VALUE | self,
|  | VALUE | val
| ) |  |

static

Definition at line 1811 of file thread.c.

References GET_THREAD, rb_secure(), and RTEST.

Referenced by Init_Thread().

static VALUE rb_thread_s_kill | ( | VALUE | obj,
|  | VALUE | th
| ) |  |

static

Definition at line 1554 of file thread.c.

References rb_thread_kill().

Referenced by Init_Thread().

static VALUE rb_thread_s_main | ( | VALUE | klass | ) |

static

Definition at line 1761 of file thread.c.

References rb_thread_main().

Referenced by Init_Thread().

static VALUE rb_thread_safe_level | ( | VALUE | thread | ) |

static

Definition at line 2007 of file thread.c.

References GetThreadPtr, INT2NUM(), and rb_thread_struct::safe_level.

Referenced by Init_Thread().

void rb_thread_schedule | ( | void |  | ) |

Definition at line 1033 of file thread.c.

References GET_THREAD, rb_thread_schedule_limits(), rb_threadptr_execute_interrupts_common(), and UNLIKELY.

Referenced by call_queue_handler(), eval_queue_handler(), invoke_queue_handler(), lib_eventloop_core(), lib_thread_callback(), proc_waitall(), rb_thread_run(), rb_thread_terminate_all(), rb_threadptr_raise(), rb_waitpid(), rbtk_EventCheckProc(), thread_s_pass(), and zstream_run().

static void rb_thread_schedule_limits | ( | unsigned long | limits_us | ) |

static

Definition at line 1016 of file thread.c.

References GET_THREAD, RB_GC_SAVE_MACHINE_CONTEXT, rb_thread_alone(), rb_thread_set_current, rb_thread_struct::running_time_us, thread_debug, and rb_thread_struct::vm.

Referenced by rb_thread_schedule(), and rb_threadptr_execute_interrupts_common().

int rb_thread_select | ( | int | max,
|  | fd_set * | read,
|  | fd_set * | write,
|  | fd_set * | except,
|  | struct timeval * | timeout
| ) |  |

Definition at line 2710 of file thread.c.

References NULL, rb_fd_copy, rb_fd_init, rb_fd_rcopy, rb_fd_term, and rb_thread_fd_select().

Referenced by old_thread_select().

void rb_thread_sleep | ( | int | sec | ) |

Definition at line 1008 of file thread.c.

References INT2FIX, rb_thread_wait_for(), and rb_time_timeval().

Referenced by pipe_open().

static void rb_thread_sleep_deadly | ( | void |  | ) |

static

Definition at line 920 of file thread.c.

References GET_THREAD, sleep_forever(), and thread_debug.

Referenced by rb_mutex_sleep_forever(), and rb_thread_stop().

void rb_thread_sleep_forever | ( | void |  | ) |

Definition at line 913 of file thread.c.

References GET_THREAD, sleep_forever(), and thread_debug.

Referenced by lib_eventloop_core(), rb_f_sleep(), and rb_thread_fd_select().

void rb_thread_start_timer_thread | ( | void |  | ) |

Definition at line 3046 of file thread.c.

References system_working.

Referenced by after_exec().

static VALUE rb_thread_status | ( | VALUE | thread | ) |

static

Definition at line 1930 of file thread.c.

References rb_thread_struct::errinfo, FIXNUM_P, GetThreadPtr, NIL_P, Qfalse, Qnil, rb_str_new2(), rb_threadptr_dead(), rb_thread_struct::status, and thread_status_name().

VALUE rb_thread_stop | ( | void |  | ) |

Definition at line 1667 of file thread.c.

References Qnil, rb_eThreadError, rb_raise(), rb_thread_alone(), and rb_thread_sleep_deadly().

Referenced by Init_Thread().

static VALUE rb_thread_stop_p | ( | VALUE | thread | ) |

static

Definition at line 1982 of file thread.c.

References GetThreadPtr, Qfalse, Qtrue, rb_threadptr_dead(), rb_thread_struct::status, THREAD_STOPPED, and THREAD_STOPPED_FOREVER.

Referenced by Init_Thread().

void rb_thread_stop_timer_thread | ( | int | close_anyway | ) |

Definition at line 3032 of file thread.c.

Referenced by before_exec(), and ruby_cleanup().

void rb_thread_terminate_all | ( | void |  | ) |

Definition at line 355 of file thread.c.

References EXEC_TAG, GET_THREAD, rb_vm_struct::inhibit_thread_creation, rb_vm_struct::living_threads, rb_vm_struct::main_thread, POP_TAG, PUSH_TAG, rb_bug(), rb_thread_alone(), rb_thread_schedule(), rb_threadptr_unlock_all_locking_mutexes(), st_foreach, terminate_i(), rb_mutex_struct::th, thread_debug, and rb_thread_struct::vm.

Referenced by ruby_cleanup().

void rb_thread_wait_fd | ( | int | fd | ) |

Definition at line 2697 of file thread.c.

References rb_thread_wait_fd_rw().

Referenced by copy_stream_fallback_body(), io_bufread(), ossl_ssl_read_internal(), rb_io_read_check(), rb_io_sysread(), rb_io_wait_readable(), rb_read_check(), rsock_s_accept(), and rsock_s_recvfrom().

static void rb_thread_wait_fd_rw | ( | int | fd,
|  | int | read
| ) |  |

static

Definition at line 2674 of file thread.c.

References NULL, rb_eIOError, rb_raise(), rb_sys_fail(), rb_thread_alone(), rb_wait_for_single_fd(), RB_WAITFD_IN, RB_WAITFD_OUT, result, and thread_debug.

Referenced by rb_thread_fd_writable(), and rb_thread_wait_fd().

void rb_thread_wait_for | ( | struct timeval | time | ) |

Definition at line 959 of file thread.c.

References GET_THREAD, and sleep_timeval().

Referenced by eventloop_sleep(), ip_eval(), ip_invoke_with_position(), ip_rb_threadTkWaitCommand(), ip_rb_threadUpdateCommand(), ip_rb_threadVwaitCommand(), lib_watchdog_core(), rb_f_sleep(), rb_mutex_wait_for(), rb_thread_fd_select(), rb_thread_sleep(), rsock_connect(), and tk_funcall().

VALUE rb_thread_wakeup | ( | VALUE | thread | ) |

Definition at line 1595 of file thread.c.

References rb_eThreadError, rb_raise(), rb_thread_wakeup_alive(), and RTEST.

Referenced by call_queue_handler(), eval_queue_handler(), Init_Thread(), invoke_queue_handler(), lib_eventloop_ensure(), rb_thread_run(), rb_threadUpdateProc(), rb_threadVwaitProc(), rb_threadWaitVisibilityProc(), and rb_threadWaitWindowProc().

VALUE rb_thread_wakeup_alive | ( | VALUE | thread | ) |

Definition at line 1604 of file thread.c.

References GetThreadPtr, Qnil, rb_threadptr_ready(), rb_thread_struct::status, THREAD_KILLED, THREAD_RUNNABLE, and THREAD_TO_KILL.

Referenced by rb_thread_wakeup().

static void rb_threadptr_add_event_hook | ( | rb_thread_t * | th,
|  | rb_event_hook_func_t | func,
|  | rb_event_flag_t | events,
|  | VALUE | data
| ) |  |

static

Definition at line 4079 of file thread.c.

References alloc_event_hook(), rb_thread_struct::event_hooks, rb_event_hook_struct::next, and thread_reset_event_flags().

Referenced by rb_thread_add_event_hook(), and thread_add_trace_func().

void rb_threadptr_check_signal | ( | rb_thread_t * | mth | ) |

Definition at line 2999 of file thread.c.

References rb_signal_buff_size(), and rb_threadptr_interrupt().

Referenced by ruby_cleanup(), and timer_thread_function().

static int rb_threadptr_dead | ( | rb_thread_t * | th | ) |

static

Definition at line 1901 of file thread.c.

References rb_thread_struct::status, and THREAD_KILLED.

Referenced by rb_thread_alive_p(), rb_thread_status(), rb_thread_stop_p(), and rb_threadptr_raise().

void rb_threadptr_exec_event_hooks | ( | rb_thread_t * | th,
|  | rb_event_flag_t | flag,
|  | VALUE | self,
|  | ID | id,
|  | VALUE | klass
| ) |  |

Definition at line 4182 of file thread.c.

References rb_thread_struct::errinfo, event_call_args::event, EVENT_RUNNING_EVENT_MASK, FALSE, id, event_call_args::id, event_call_args::klass, event_call_args::proc, event_call_args::self, event_call_args::th, thread_exec_event_hooks(), and thread_suppress_tracing().

void rb_threadptr_execute_interrupts | ( | rb_thread_t * | th | ) |

Definition at line 1333 of file thread.c.

References rb_threadptr_execute_interrupts_common().

static void rb_threadptr_execute_interrupts_common | ( | rb_thread_t * | th | ) |

static

Definition at line 1273 of file thread.c.

References ATOMIC_EXCHANGE, rb_thread_struct::cfp, eKillSignal, err, rb_thread_struct::errinfo, eTerminateSignal, EXEC_EVENT_HOOK, INT2FIX, rb_thread_struct::interrupt_flag, rb_vm_struct::main_thread, PRIdVALUE, rb_thread_struct::priority, rb_thread_struct::raised_flag, rb_exc_raise(), rb_gc_finalize_deferred(), rb_get_next_signal(), rb_signal_exec(), rb_thread_schedule_limits(), RUBY_EVENT_SWITCH, rb_thread_struct::running_time_us, rb_control_frame_t::self, rb_thread_struct::status, TAG_FATAL, TH_JUMP_TAG, thread_debug, THREAD_RUNNABLE, rb_thread_struct::thrown_errinfo, and rb_thread_struct::vm.

Referenced by rb_thread_execute_interrupts(), rb_thread_schedule(), and rb_threadptr_execute_interrupts().

void rb_threadptr_interrupt | ( | rb_thread_t * | th | ) |

Definition at line 292 of file thread.c.

References rb_unblock_callback::arg, rb_unblock_callback::func, rb_thread_struct::interrupt_lock, RUBY_VM_SET_INTERRUPT, and rb_thread_struct::unblock.

Referenced by rb_thread_kill(), rb_threadptr_check_signal(), rb_threadptr_ready(), ruby_cleanup(), terminate_i(), and thread_start_func_2().

static VALUE rb_threadptr_raise | ( | rb_thread_t * | th,
|  | int | argc,
|  | VALUE * | argv
| ) |  |

static

Definition at line 1361 of file thread.c.

References Qnil, rb_thread_struct::raised_flag, rb_make_exception(), rb_thread_schedule(), rb_threadptr_dead(), rb_threadptr_ready(), and rb_thread_struct::thrown_errinfo.

Referenced by rb_check_deadlock(), rb_threadptr_signal_exit(), rb_threadptr_signal_raise(), thread_raise_m(), and thread_start_func_2().

static void rb_threadptr_ready | ( | rb_thread_t * | th | ) |

static

Definition at line 1355 of file thread.c.

References rb_threadptr_interrupt().

Referenced by rb_thread_wakeup_alive(), and rb_threadptr_raise().

static int rb_threadptr_remove_event_hook | ( | rb_thread_t * | th,
|  | rb_event_hook_func_t | func
| ) |  |

static

Definition at line 4259 of file thread.c.

References defer_remove_event_hook(), rb_thread_struct::event_hooks, EVENT_RUNNING_THREAD, remove_event_hook(), thread_reset_event_flags(), and rb_thread_struct::tracing.

Referenced by clear_trace_func_i(), rb_thread_remove_event_hook(), and thread_set_trace_func_m().

int rb_threadptr_reset_raised | ( | rb_thread_t * | th | ) |

Definition at line 1428 of file thread.c.

References RAISED_EXCEPTION, and rb_thread_struct::raised_flag.

Referenced by error_handle(), setup_exception(), and thread_suppress_tracing().

int rb_threadptr_set_raised | ( | rb_thread_t * | th | ) |

Definition at line 1418 of file thread.c.

References RAISED_EXCEPTION, and rb_thread_struct::raised_flag.

Referenced by error_handle(), setup_exception(), and thread_suppress_tracing().

void rb_threadptr_signal_exit | ( | rb_thread_t * | th | ) |

Definition at line 1392 of file thread.c.

References argv, rb_vm_struct::main_thread, rb_eSystemExit, rb_str_new2(), rb_threadptr_raise(), and rb_thread_struct::vm.

Referenced by rb_signal_exec().

void rb_threadptr_signal_raise | ( | rb_thread_t * | th,
|  | int | sig
| ) |  |

Definition at line 1382 of file thread.c.

References argv, INT2FIX, rb_vm_struct::main_thread, rb_eSignal, rb_threadptr_raise(), and rb_thread_struct::vm.

Referenced by rb_signal_exec().

void rb_threadptr_unlock_all_locking_mutexes | ( | rb_thread_t * | th | ) |

Definition at line 338 of file thread.c.

References err, rb_thread_struct::keeping_mutexes, rb_mutex_struct::next_mutex, rb_bug(), and rb_mutex_unlock_th().

Referenced by rb_thread_terminate_all(), ruby_cleanup(), and thread_start_func_2().

void rb_vm_gvl_destroy | ( | rb_vm_t * | vm | ) |

Definition at line 246 of file thread.c.

Referenced by ruby_vm_destruct().

int rb_wait_for_single_fd | ( | int | fd,
|  | int | events,
|  | struct timeval * | tv
| ) |  |

Definition at line 2950 of file thread.c.

References select_args::as, errno, select_args::error, select_args::except, select_args::fd, init_set_fd(), NULL, rb_ensure(), RB_WAITFD_IN, RB_WAITFD_OUT, RB_WAITFD_PRI, select_args::read, select_single(), select_single_cleanup(), select_args::tv, and select_args::write.

Referenced by io_wait(), rb_io_wait_readable(), rb_io_wait_writable(), rb_thread_wait_fd_rw(), wait_connectable(), and wait_for_single_fd().

static VALUE recursive_check | ( | VALUE | list,
|  | VALUE | obj_id,
|  | VALUE | paired_obj_id
| ) |  |

static

Definition at line 3843 of file thread.c.

References NIL_P, Qfalse, Qtrue, Qundef, rb_hash_lookup, rb_hash_lookup2(), T_HASH, and TYPE.

Referenced by exec_recursive().

static VALUE recursive_list_access | ( | void |  | ) |

static

Definition at line 3814 of file thread.c.

References hash(), ID2SYM, list, NIL_P, OBJ_UNTRUST, Qnil, rb_frame_this_func(), rb_hash_aref(), rb_hash_aset(), rb_hash_new(), rb_thread_current(), rb_thread_local_aref(), rb_thread_local_aset(), sym, T_HASH, and TYPE.

Referenced by exec_recursive().

static void recursive_pop | ( | VALUE | list,
|  | VALUE | obj,
|  | VALUE | paired_obj
| ) |  |

static

Definition at line 3902 of file thread.c.

References ID2SYM, Qundef, rb_eTypeError, rb_frame_this_func(), rb_hash_delete(), rb_hash_lookup2(), rb_inspect(), rb_raise(), rb_thread_current(), RHASH_EMPTY_P, StringValuePtr, T_HASH, and TYPE.

Referenced by exec_recursive(), and exec_recursive_i().

static void recursive_push | ( | VALUE | list,
|  | VALUE | obj,
|  | VALUE | paired_obj
| ) |  |

static

Definition at line 3871 of file thread.c.

References OBJ_UNTRUST, Qtrue, Qundef, rb_hash_aset(), rb_hash_lookup2(), rb_hash_new(), T_HASH, and TYPE.

Referenced by exec_recursive(), and exec_recursive_i().

static int remove_defered_event_hook | ( | rb_event_hook_t ** | root | ) |

static

Definition at line 4240 of file thread.c.

References rb_event_hook_struct::flag, rb_event_hook_struct::next, RUBY_EVENT_REMOVED, and xfree().

Referenced by thread_exec_event_hooks().

static int remove_event_hook | ( | rb_event_hook_t ** | root,
|  | rb_event_hook_func_t | func
| ) |  |

static

Definition at line 4221 of file thread.c.

References rb_event_hook_struct::flag, rb_event_hook_struct::func, rb_event_hook_struct::next, RUBY_EVENT_REMOVED, and xfree().

Referenced by rb_remove_event_hook(), and rb_threadptr_remove_event_hook().

static VALUE remove_from_join_list | ( | VALUE | arg | ) |

static

Definition at line 659 of file thread.c.

References rb_thread_struct::join_list_head, rb_thread_struct::join_list_next, p, Qnil, rb_thread_struct::status, join_arg::target, THREAD_KILLED, and join_arg::waiting.

Referenced by thread_join().

static void reset_unblock_function | ( | rb_thread_t * | th,
|  | const struct rb_unblock_callback * | old
| ) |  |

static

Definition at line 284 of file thread.c.

References rb_thread_struct::interrupt_lock, and rb_thread_struct::unblock.

Referenced by blocking_region_end(), and rb_mutex_lock().

int ruby_native_thread_p | ( | void |  | ) |

Definition at line 4721 of file thread.c.

VALUE ruby_suppress_tracing | ( | VALUE(*)(VALUE, int) | func,
|  | VALUE | arg,
|  | int | always
| ) |  |

Definition at line 4538 of file thread.c.

References EVENT_RUNNING_TRACE, func, GET_THREAD, and thread_suppress_tracing().

Referenced by call_trace_func(), and yycompile().

int ruby_thread_has_gvl_p | ( | void |  | ) |

Definition at line 1241 of file thread.c.

References rb_thread_struct::blocking_region_buffer.

Referenced by garbage_collect_with_gvl(), negative_size_allocation_error(), and ruby_memerror().

void ruby_thread_init_stack | ( | rb_thread_t * | th | ) |

Definition at line 418 of file thread.c.

Referenced by Init_BareVM().

void ruby_thread_stack_overflow | ( | rb_thread_t * | th | ) |

Definition at line 1406 of file thread.c.

References rb_thread_struct::errinfo, rb_thread_struct::raised_flag, rb_exc_raise(), sysstack_error, TAG_RAISE, and TH_JUMP_TAG.

static int running_vm_event_hooks | ( | st_data_t | key,
|  | st_data_t | val,
|  | st_data_t | data
| ) |  |

static

Definition at line 4290 of file thread.c.

References EVENT_RUNNING_VM, ST_CONTINUE, ST_STOP, thval2thread_t(), and rb_thread_struct::tracing.

Referenced by vm_event_hooks_running_thread().

static rb_event_hook_t* search_live_hook | ( | rb_event_hook_t * | hook | ) |

static

Definition at line 4279 of file thread.c.

References rb_event_hook_struct::flag, rb_event_hook_struct::next, NULL, and RUBY_EVENT_REMOVED.

Referenced by rb_remove_event_hook().

static VALUE select_single | ( | VALUE | ptr | ) |

static

Definition at line 2916 of file thread.c.

References select_args::as, errno, select_args::error, select_args::except, select_args::fd, rb_fd_isset, rb_thread_fd_select(), RB_WAITFD_IN, RB_WAITFD_OUT, RB_WAITFD_PRI, select_args::read, select_args::tv, and select_args::write.

Referenced by rb_wait_for_single_fd().

static VALUE select_single_cleanup | ( | VALUE | ptr | ) |

static

Definition at line 2938 of file thread.c.

References select_args::except, rb_fd_term, select_args::read, and select_args::write.

Referenced by rb_wait_for_single_fd().

static void set_threads_event_flags | ( | int | flag | ) |

static

Definition at line 4120 of file thread.c.

References GET_VM, set_threads_event_flags_i(), and st_foreach.

Referenced by rb_add_event_hook(), and rb_remove_event_hook().

static int set_threads_event_flags_i | ( | st_data_t | key,
|  | st_data_t | val,
|  | st_data_t | flag
| ) |  |

static

Definition at line 4104 of file thread.c.

References rb_thread_struct::event_flags, GetThreadPtr, RUBY_EVENT_VM, and ST_CONTINUE.

Referenced by set_threads_event_flags().

static VALUE set_trace_func | ( | VALUE | obj,
|  | VALUE | trace
| ) |  |

static

Definition at line 4389 of file thread.c.

References call_trace_func(), EVENT_RUNNING_NOTHING, GET_THREAD, NIL_P, Qnil, rb_add_event_hook(), rb_eTypeError, rb_obj_is_proc(), rb_raise(), rb_remove_event_hook(), and RUBY_EVENT_ALL.

Referenced by Init_Thread().

static void set_unblock_function | ( | rb_thread_t * | th,
|  | rb_unblock_function_t * | func,
|  | void * | arg,
|  | struct rb_unblock_callback * | old
| ) |  |

static

Definition at line 265 of file thread.c.

References rb_unblock_callback::arg, arg, func, rb_unblock_callback::func, rb_thread_struct::interrupt_flag, rb_thread_struct::interrupt_lock, RUBY_VM_CHECK_INTS, and rb_thread_struct::unblock.

Referenced by rb_mutex_lock().

static void sleep_for_polling | ( | rb_thread_t * | th | ) |

static

Definition at line 950 of file thread.c.

References sleep_timeval(), timeval::tv_sec, and timeval::tv_usec.

Referenced by rb_thread_polling().

static void sleep_forever | ( | rb_thread_t * | th,
|  | int | nodeadlock
| ) |  |

static

Definition at line 844 of file thread.c.

References rb_check_deadlock(), RUBY_VM_CHECK_INTS, rb_vm_struct::sleeper, rb_thread_struct::status, THREAD_STOPPED, THREAD_STOPPED_FOREVER, and rb_thread_struct::vm.

Referenced by rb_thread_sleep_deadly(), rb_thread_sleep_forever(), and thread_join_sleep().

static void sleep_timeval | ( | rb_thread_t * | th,
|  | struct timeval | time
| ) |  |

static

Definition at line 881 of file thread.c.

References getclockofday(), RUBY_VM_CHECK_INTS, rb_thread_struct::status, thread_debug, THREAD_STOPPED, timeval::tv_sec, and timeval::tv_usec.

Referenced by rb_thread_wait_for(), sleep_for_polling(), and sleep_wait_for_interrupt().

static void sleep_wait_for_interrupt | ( | rb_thread_t * | th,
|  | double | sleepsec
| ) |  |

static

Definition at line 944 of file thread.c.

References double2timeval(), and sleep_timeval().

Referenced by thread_join_sleep().

static void st_delete_wrap | ( | st_table * | table,
|  | st_data_t | key
| ) |  |

inline static

Definition at line 80 of file thread.c.

References st_delete.

Referenced by rb_thread_local_aset(), thread_create_core(), and thread_start_func_2().

static int terminate_atfork_before_exec_i | ( | st_data_t | key,
|  | st_data_t | val,
|  | st_data_t | current_th
| ) |  |

static

Definition at line 3119 of file thread.c.

References GetThreadPtr, ST_CONTINUE, and thread_cleanup_func_before_exec().

Referenced by rb_thread_atfork_before_exec().

static int terminate_atfork_i | ( | st_data_t | key,
|  | st_data_t | val,
|  | st_data_t | current_th
| ) |  |

static

Definition at line 3092 of file thread.c.

References GetThreadPtr, rb_thread_struct::keeping_mutexes, NULL, rb_mutex_abandon_all(), ST_CONTINUE, thread_cleanup_func(), and TRUE.

Referenced by rb_thread_atfork().

static int terminate_i | ( | st_data_t | key,
|  | st_data_t | val,
|  | rb_thread_t * | main_thread
| ) |  |

static

Definition at line 307 of file thread.c.

References eTerminateSignal, GetThreadPtr, rb_threadptr_interrupt(), ST_CONTINUE, rb_thread_struct::status, thread_debug, THREAD_TO_KILL, and rb_thread_struct::thrown_errinfo.

Referenced by rb_thread_terminate_all().

static VALUE thgroup_add | ( | VALUE | group,
|  | VALUE | thread
| ) |  |

static

Definition at line 3298 of file thread.c.

References thgroup::enclosed, GetThreadPtr, thgroup::group, OBJ_FROZEN, Qnil, rb_eThreadError, rb_raise(), rb_secure(), rb_thread_struct::thgroup, thgroup_data_type, and TypedData_Get_Struct.

Referenced by Init_Thread().

static VALUE thgroup_enclose | ( | VALUE | group | ) |

static

Definition at line 3240 of file thread.c.

References thgroup::enclosed, thgroup::group, thgroup_data_type, and TypedData_Get_Struct.

Referenced by Init_Thread().

static VALUE thgroup_enclosed_p | ( | VALUE | group | ) |

static

Definition at line 3260 of file thread.c.

References thgroup::enclosed, Qfalse, Qtrue, thgroup_data_type, and TypedData_Get_Struct.

Referenced by Init_Thread().

static VALUE thgroup_list | ( | VALUE | group | ) |

static

Definition at line 3209 of file thread.c.

References thgroup_list_params::ary, GET_THREAD, thgroup_list_params::group, rb_ary_new(), st_foreach, and thgroup_list_i().

Referenced by Init_Thread().

static int thgroup_list_i | ( | st_data_t | key,
|  | st_data_t | val,
|  | st_data_t | data
| ) |  |

static

Definition at line 3184 of file thread.c.

References GetThreadPtr, thgroup_list_params::group, rb_ary_push(), ST_CONTINUE, and rb_thread_struct::thgroup.

Referenced by thgroup_list().

static size_t thgroup_memsize | ( | const void * | ptr | ) |

static

Definition at line 3143 of file thread.c.

static VALUE thgroup_s_alloc | ( | VALUE | klass | ) |

static

Definition at line 3166 of file thread.c.

References thgroup::enclosed, thgroup::group, thgroup_data_type, and TypedData_Make_Struct.

Referenced by Init_Thread().

static void thread_add_trace_func | ( | rb_thread_t * | th,
|  | VALUE | trace
| ) |  |

static

Definition at line 4407 of file thread.c.

References call_trace_func(), rb_eTypeError, rb_obj_is_proc(), rb_raise(), rb_threadptr_add_event_hook(), and RUBY_EVENT_ALL.

Referenced by thread_add_trace_func_m(), and thread_set_trace_func_m().

static VALUE thread_add_trace_func_m | ( | VALUE | obj,
|  | VALUE | trace
| ) |  |

static

Definition at line 4425 of file thread.c.

References GetThreadPtr, event_call_args::th, and thread_add_trace_func().

Referenced by Init_Thread().

static void thread_cleanup_func | ( | void * | th_ptr,
|  | int | atfork
| ) |  |

static

Definition at line 396 of file thread.c.

References rb_thread_struct::interrupt_lock, rb_thread_struct::locking_mutex, Qfalse, rb_mutex_struct::th, and thread_cleanup_func_before_exec().

Referenced by terminate_atfork_i().

static void thread_cleanup_func_before_exec | ( | void * | th_ptr | ) |

static

Definition at line 385 of file thread.c.

References rb_thread_struct::machine_stack_end, rb_thread_struct::machine_stack_start, rb_thread_struct::status, rb_mutex_struct::th, and THREAD_KILLED.

Referenced by terminate_atfork_before_exec_i(), and thread_cleanup_func().

static VALUE thread_create_core | ( | VALUE | thval,
|  | VALUE | args,
|  | VALUE(*)(ANYARGS) | fn
| ) |  |

static

Definition at line 547 of file thread.c.

References args, err, rb_thread_struct::event_flags, rb_thread_struct::first_args, rb_thread_struct::first_func, rb_thread_struct::first_proc, GET_THREAD, GET_VM, GetThreadPtr, rb_thread_struct::interrupt_lock, rb_vm_struct::living_threads, NULL, OBJ_FROZEN, rb_thread_struct::priority, Qfalse, rb_block_proc(), rb_eThreadError, rb_raise(), RUBY_EVENT_VM, rb_thread_struct::self, st_delete_wrap(), st_insert, rb_thread_struct::status, rb_mutex_struct::th, rb_thread_struct::thgroup, rb_thread_struct::thread_id, THREAD_KILLED, and rb_thread_struct::vm.

Referenced by rb_thread_create(), thread_initialize(), and thread_start().

static VALUE thread_exec_event_hooks | ( | VALUE | args,
|  | int | running
| ) |  |

static

Definition at line 4144 of file thread.c.

References event_call_args::event, rb_thread_struct::event_flags, rb_vm_struct::event_hooks, rb_thread_struct::event_hooks, EVENT_RUNNING_THREAD, EVENT_RUNNING_VM, exec_event_hooks(), event_call_args::id, event_call_args::klass, NULL, rb_mRubyVMFrozenCore, remove_defered_event_hook(), removed, RUBY_EVENT_VM, event_call_args::self, event_call_args::th, rb_thread_struct::tracing, and rb_thread_struct::vm.

Referenced by rb_threadptr_exec_event_hooks().

static int thread_fd_close_i | ( | st_data_t | key,
|  | st_data_t | val,
|  | st_data_t | data
| ) |  |

static

Definition at line 1445 of file thread.c.

References rb_unblock_callback::arg, rb_unblock_callback::func, GetThreadPtr, rb_thread_struct::interrupt_lock, ruby_error_closed_stream, RUBY_VM_SET_INTERRUPT, rb_vm_struct::special_exceptions, ST_CONTINUE, THREAD_IO_WAITING_P, rb_thread_struct::thrown_errinfo, rb_thread_struct::unblock, rb_thread_struct::vm, and rb_thread_struct::waiting_fd.

Referenced by rb_thread_fd_close().

static VALUE thread_initialize | ( | VALUE | thread,
|  | VALUE | args
| ) |  |

static

Definition at line 618 of file thread.c.

References rb_thread_struct::first_args, rb_thread_struct::first_proc, GetThreadPtr, NIL_P, NUM2INT, RARRAY_PTR, rb_block_given_p(), rb_eThreadError, rb_proc_location(), rb_raise(), RSTRING_PTR, RTEST, rb_mutex_struct::th, and thread_create_core().

Referenced by Init_Thread().

static VALUE thread_join | ( | rb_thread_t * | target_th,
|  | double | delay
| ) |  |

static

Definition at line 706 of file thread.c.

References DELAY_INFTY, err, rb_thread_struct::errinfo, FIXNUM_P, join_arg::forever, GET_THREAD, GET_THROWOBJ_STATE, GET_THROWOBJ_VAL, rb_thread_struct::join_list_head, rb_thread_struct::join_list_next, join_arg::limit, Qnil, rb_ensure(), rb_exc_raise(), rb_vm_make_jump_tag_but_local_jump(), remove_from_join_list(), rb_thread_struct::self, rb_thread_struct::status, T_NODE, join_arg::target, thread_debug, rb_thread_struct::thread_id, thread_join_sleep(), THREAD_KILLED, timeofday(), TYPE, and join_arg::waiting.

Referenced by thread_join_m(), and thread_value().

static VALUE thread_join_m | ( | int | argc,
|  | VALUE * | argv,
|  | VALUE | self
| ) |  |

static

Definition at line 789 of file thread.c.

References DELAY_INFTY, GetThreadPtr, join_arg::limit, NIL_P, rb_num2dbl(), rb_scan_args(), and thread_join().

Referenced by Init_Thread().

static VALUE thread_join_sleep | ( | VALUE | arg | ) |

static

Definition at line 680 of file thread.c.

References join_arg::forever, join_arg::limit, p, Qfalse, Qtrue, sleep_forever(), sleep_wait_for_interrupt(), rb_thread_struct::status, join_arg::target, thread_debug, rb_thread_struct::thread_id, THREAD_KILLED, timeofday(), and join_arg::waiting.

Referenced by thread_join().

static int thread_keys_i | ( | ID | key,
|  | VALUE | value,
|  | VALUE | ary
| ) |  |

static

Definition at line 2155 of file thread.c.

References ID2SYM, rb_ary_push(), and ST_CONTINUE.

Referenced by rb_thread_keys().

static int thread_list_i | ( | st_data_t | key,
|  | st_data_t | val,
|  | void * | data
| ) |  |

static

Definition at line 1678 of file thread.c.

References GetThreadPtr, rb_ary_push(), rb_thread_struct::self, ST_CONTINUE, rb_thread_struct::status, THREAD_RUNNABLE, THREAD_STOPPED, THREAD_STOPPED_FOREVER, and THREAD_TO_KILL.

Referenced by rb_thread_list().

static VALUE thread_raise_m | ( | int | argc,
|  | VALUE * | argv,
|  | VALUE | self
| ) |  |

static

Definition at line 1491 of file thread.c.

References GetThreadPtr, Qnil, and rb_threadptr_raise().

Referenced by Init_Thread().

static void thread_reset_event_flags | ( | rb_thread_t * | th | ) |

static

Definition at line 4065 of file thread.c.

References rb_thread_struct::event_flags, rb_thread_struct::event_hooks, rb_event_hook_struct::flag, rb_event_hook_struct::next, RUBY_EVENT_REMOVED, and RUBY_EVENT_VM.

Referenced by rb_threadptr_add_event_hook(), and rb_threadptr_remove_event_hook().

static VALUE thread_s_current | ( | VALUE | klass | ) |

static

Definition at line 1742 of file thread.c.

References rb_thread_current().

Referenced by Init_Thread().

static VALUE thread_s_new | ( | int | argc,
|  | VALUE * | argv,
|  | VALUE | klass
| ) |  |

static

Definition at line 583 of file thread.c.

References rb_thread_struct::first_args, GET_VM, GetThreadPtr, rb_class2name(), rb_eThreadError, rb_obj_call_init(), rb_raise(), rb_thread_alloc(), and rb_mutex_struct::th.

Referenced by Init_Thread().

static VALUE thread_s_pass | ( | VALUE | klass | ) |

static

Definition at line 1262 of file thread.c.

References Qnil, and rb_thread_schedule().

Referenced by Init_Thread().

static VALUE thread_set_trace_func_m | ( | VALUE | obj,
|  | VALUE | trace
| ) |  |

static

Definition at line 4444 of file thread.c.

References call_trace_func(), EVENT_RUNNING_NOTHING, GetThreadPtr, NIL_P, Qnil, rb_threadptr_remove_event_hook(), event_call_args::th, thread_add_trace_func(), and rb_thread_struct::tracing.

Referenced by Init_Thread().

static VALUE thread_start | ( | VALUE | klass,
|  | VALUE | args
| ) |  |

static

Definition at line 611 of file thread.c.

References rb_thread_alloc(), and thread_create_core().

Referenced by Init_Thread().

static int thread_start_func_2 | ( | rb_thread_t * | th,
|  | VALUE * | stack_start,
|  | VALUE * | register_stack_start
| ) |  |

static

Definition at line 424 of file thread.c.

References rb_thread_struct::abort_on_exception, rb_proc_t::block, rb_thread_struct::errinfo, EXEC_TAG, rb_thread_struct::first_args, rb_thread_struct::first_func, rb_thread_struct::first_proc, GetProcPtr, rb_thread_struct::join_list_head, rb_thread_struct::join_list_next, rb_block_struct::lfp, rb_vm_struct::living_threads, rb_thread_struct::local_lfp, rb_thread_struct::local_svar, rb_thread_struct::locking_mutex, rb_thread_struct::machine_stack_start, rb_vm_struct::main_thread, NIL_P, PRIxVALUE, Qfalse, Qnil, RARRAY_LEN, RARRAY_PTR, rb_bug(), rb_check_deadlock(), rb_errinfo, rb_eSecurityError, rb_eSystemExit, rb_exc_new3(), rb_obj_is_kind_of(), rb_sprintf(), rb_thread_recycle_stack_release(), rb_thread_set_current, rb_threadptr_interrupt(), rb_threadptr_raise(), rb_threadptr_unlock_all_locking_mutexes(), rb_vm_invoke_proc(), rb_thread_struct::root_fiber, RTEST, ruby_debug, rb_thread_struct::safe_level, SAVE_ROOT_JMPBUF, rb_block_struct::self, rb_thread_struct::self, st_delete_wrap(), rb_thread_struct::stack, rb_thread_struct::status, T_OBJECT, TAG_FATAL, TH_POP_TAG, TH_PUSH_TAG, rb_vm_struct::thread_abort_on_exception, thread_debug, THREAD_KILLED, THREAD_RUNNABLE, THREAD_STOPPED, THREAD_STOPPED_FOREVER, TYPE, rb_thread_struct::value, and rb_thread_struct::vm.

static const char* thread_status_name | ( | enum rb_thread_status | status | ) |

static

Definition at line 1883 of file thread.c.

References THREAD_KILLED, THREAD_RUNNABLE, THREAD_STOPPED, THREAD_STOPPED_FOREVER, and THREAD_TO_KILL.

Referenced by rb_thread_inspect(), and rb_thread_status().

static VALUE thread_suppress_tracing | ( | rb_thread_t * | th,
|  | int | ev,
|  | VALUE(*)(VALUE, int) | func,
|  | VALUE | arg,
|  | int | always
| ) |  |

static

Definition at line 4545 of file thread.c.

References arg, ev, EXEC_TAG, JUMP_TAG, POP_TAG, PUSH_TAG, Qnil, rb_threadptr_reset_raised(), rb_threadptr_set_raised(), result, rb_thread_struct::state, and rb_thread_struct::tracing.

Referenced by rb_threadptr_exec_event_hooks(), and ruby_suppress_tracing().

static VALUE thread_value | ( | VALUE | self | ) |

static

Definition at line 817 of file thread.c.

References DELAY_INFTY, GetThreadPtr, thread_join(), and rb_thread_struct::value.

Referenced by Init_Thread().

static rb_thread_t* thval2thread_t | ( | VALUE | thval | ) |

static

Definition at line 4089 of file thread.c.

References GetThreadPtr.

Referenced by rb_thread_add_event_hook(), rb_thread_remove_event_hook(), and running_vm_event_hooks().

static double timeofday | ( | void |  | ) |

static

Definition at line 927 of file thread.c.

References gettimeofday(), NULL, timespec::tv_nsec, timeval::tv_sec, timespec::tv_sec, and timeval::tv_usec.

Referenced by do_select(), thread_join(), and thread_join_sleep().

static void timer_thread_function | ( | void * | arg | ) |

static

Definition at line 3009 of file thread.c.

References GET_VM, rb_vm_struct::main_thread, rb_threadptr_check_signal(), RUBY_VM_SET_TIMER_INTERRUPT, and rb_vm_struct::running_thread.

static void update_coverage | ( | rb_event_flag_t | event,
|  | VALUE | proc,
|  | VALUE | self,
|  | ID | id,
|  | VALUE | klass
| ) |  |

static

Definition at line 4800 of file thread.c.

References count, coverage(), FIX2LONG, GET_THREAD, LONG2FIX, POSFIXABLE, Qnil, RARRAY_PTR, rb_sourceline(), and RBASIC.

Referenced by rb_reset_coverages(), and rb_set_coverages().

static rb_thread_t* vm_event_hooks_running_thread | ( | rb_vm_t * | vm | ) |

static

Definition at line 4299 of file thread.c.

References rb_vm_struct::living_threads, NULL, running_vm_event_hooks(), and st_foreach.

Referenced by rb_remove_event_hook().

static int vm_living_thread_num | ( | rb_vm_t * | vm | ) |

static

Definition at line 2162 of file thread.c.

References rb_vm_struct::living_threads, and st_table::num_entries.

Referenced by rb_check_deadlock(), rb_mutex_lock(), and rb_thread_alone().

## Variable Documentation

const rb_data_type_t barrier_data_type

static

Initial value:
= {
"barrier",
{barrier_mark, 0, 0,},
}

Definition at line 3754 of file thread.c.

const rb_data_type_t mutex_data_type

static

Initial value:
= {
"mutex",
{mutex_mark, mutex_free, mutex_memsize,},
}

Definition at line 3386 of file thread.c.

VALUE rb_cBarrier

Definition at line 63 of file thread.c.

Referenced by rb_barrier_new().

VALUE rb_cMutex

Definition at line 62 of file thread.c.

Referenced by Init_Thread(), and rb_mutex_new().

ID recursive_key

static

Definition at line 3805 of file thread.c.

volatile int system_working = 1

static

Definition at line 75 of file thread.c.

Referenced by rb_thread_start_timer_thread().

const rb_data_type_t thgroup_data_type

static

Initial value:
= {
"thgroup",
{NULL, RUBY_TYPED_DEFAULT_FREE, thgroup_memsize,},
}

Definition at line 3148 of file thread.c.

Referenced by thgroup_add(), thgroup_enclose(), thgroup_enclosed_p(), and thgroup_s_alloc().